<template>
  <article class="view view--search-rebuild">
    <ActionButton
      button-text="Rebuild"
      busy-button-text="Rebuilding"
      button-icon-class="bi bi-bricks"
      :resource="rebuildApiUrl"
      :request="request"
      @click="onActionButtonClick"
      @success="onActionButtonSuccess"
      @failure="onActionButtonFailure"
    />

    <ModalWindow
      id="rebuild-search-index-modal"
      title="Rebuild search index"
      :buttons="modalButtons"
      :dismisable="!busy"
      :show="modalShown"
      @button="onModalButton"
    >
      <p v-html="message" v-if="hasMessage"></p>
      <ProgressBar :progress="progress" />
    </ModalWindow>
  </article>
</template>

<script>
import { ref, computed } from 'vue'
import { ModalWindow, ProgressBar, useApi, useNotification, useEventBus } from '../../../core'
import { useAuth } from '../../../identity'
import { ActionButton } from '../../../identity'
import SearchApi from '../../api/search-api.js'

export default {
  name: 'SearchRebuildView',
  components: {
    ActionButton,
    ModalWindow,
    ProgressBar,
  },
  setup() {
    const api = useApi()
    const auth = useAuth()
    const eventBus = useEventBus()
    const notify = useNotification()
    const searchApi = new SearchApi(api, auth)

    const modalShown = ref(false)
    const busy = ref(false)
    const previousRequest = ref(undefined)
    const connectionId = ref('')
    const message = ref('')
    const progress = ref(0)

    const rebuildApiUrl = computed(() => {
      return searchApi.getRebuildUrl('site')
    })

    const request = computed(() => {
      return { connectionId: connectionId.value }
    })

    const hasMessage = computed(() => {
      return Boolean(message.value)
    })

    const modalButtons = computed(() => {
      return [
        {
          id: 'ok',
          text: 'Ok',
          class: 'btn btn-primary me-auto',
          iconClass: 'bi bi-check-lg',
          disabled: busy.value,
          visible: true,
        },
        {
          id: 'cancel',
          text: 'Cancel',
          class: 'btn btn-primary',
          iconClass: 'bi bi-x-lg',
          disabled: !busy.value,
          visible: true,
        },
      ]
    })

    const onActionButtonClick = (request) => {
      message.value = 'Fetching data...'
      progress.value = 0
      previousRequest.value = request
      modalShown.value = true
      busy.value = true
    }

    const onActionButtonSuccess = (response) => {
      message.value = response.data.message
      progress.value = 100
      busy.value = false
    }

    const onActionButtonFailure = (response) => {
      notify.error('There was a problem.', response)
      busy.value = false
    }

    const onModalButton = (id) => {
      switch (id) {
        case 'ok':
          ok()
          break
        case 'cancel':
          cancel()
          break
      }
    }

    const ok = () => {
      modalShown.value = false
    }

    const cancel = () => {
      previousRequest.value.abort()
      modalShown.value = false
    }

    eventBus.on('signalr-progress', (data) => {
      message.value = data.message
      progress.value = data.percentage
    })

    return {
      modalShown,
      busy,
      previousRequest,
      connectionId,
      message,
      progress,
      rebuildApiUrl,
      request,
      hasMessage,
      modalButtons,
      onActionButtonClick,
      onActionButtonSuccess,
      onActionButtonFailure,
      onModalButton,
    }
  },
}
</script>
